class Panel::News::BackEnd::NewsBulletinsController < OrbitBackendController
  
  before_filter :authenticate_user!
  before_filter :is_admin?

  def index
    # @news_bulletins = NewsBulletin.all
    # @news_bulletins = NewsBulletin.desc("postdate desc")
	  get_categorys(params[:news_bulletin_category_id])
	  get_tags

    @filter = params[:filter]
    new_filter = params[:new_filter]

    if @filter && params[:clear]
      @filter.delete(params[:type])
    elsif @filter && new_filter
      if @filter.has_key?(new_filter[:type]) && @filter[new_filter[:type]].include?(new_filter[:id].to_s)
        @filter[new_filter[:type]].delete(new_filter[:id].to_s)
      elsif @filter.has_key?(new_filter[:type])
        @filter[new_filter[:type]] << new_filter[:id].to_s
      else
        @filter.merge!({new_filter[:type] => [new_filter[:id].to_s]})
      end
    elsif new_filter
      @filter = {new_filter[:type] => [new_filter[:id].to_s]}
    end

    # @news_bulletins = NewsBulletin.where("news_bulletin_category_id" => params[:news_bulletin_category_id]).desc("postdate") if params[:news_bulletin_category_id]
    
  	# @news_bulletins = NewsBulletin.search(params[:search], params[:category_id])
    # @news_bulletins = NewsBulletin.all.order_by([params[:sort], params[:direction]])


    # @news_bulletins = (params[:sort] || @filter) ? get_sorted_and_filtered_news_bulletins : NewsBulletin.all.page(params[:page]).per(10)
    @news_bulletins = (params[:sort] || @filter) ? get_sorted_and_filtered("news_bulletin") : NewsBulletin.all.page(params[:page]).per(10)
  	@news_bulletin_categories = NewsBulletinCategory.all

    @news_bulletin_link = NewsBulletinLink.new
    @link_url = panel_news_back_end_news_bulletins_path
	
    @news_bulletin_file = NewsBulletinFile.new
    @file_url = panel_news_back_end_news_bulletins_path
	
    respond_to do |format|
      format.html # index.html.erb
      format.js { }
      format.xml  { render :xml => @news_bulletins }
    end
  end

  # GET /news_bulletins/1
  # GET /news_bulletins/1.xml
  def show
    @news_bulletin = NewsBulletin.find(params[:id])
	get_tags
	# get_categorys
	
    # @news_bulletin_categorys = NewsBulletinCategory.where("_id" => params[:id])
	
    # if params[:id]
      # @news_bulletins = NewsBulletin.where("news_bulletin_category_id" => params[:id])
    # else
      # @news_bulletins = NewsBulletin.desc("postdate desc")
    # end

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @news_bulletin }
    end
  end

  # GET /news_bulletins/new
  # GET /news_bulletins/new.xml
  def new
    @news_bulletin = NewsBulletin.new
	
	@link_url = panel_news_back_end_news_bulletins_path
    
	# @news_bulletin.news_bulletin_files.build
	# @news_bulletin.news_bulletin_files.new
	
	get_categorys
	get_tags

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @news_bulletin }
    end
  end

  # GET /news_bulletins/1/edit
  def edit
    @news_bulletin = NewsBulletin.find(params[:id])
    if !current_user.admin? && (@news_bulletin.is_rejected? || @news_bulletin.is_checked?)
      redirect_to :action => :index
    else
      # @summary_variable = @news_bulletin.summary_variable
  	
    	@link_url = panel_news_back_end_news_bulletin_path(@news_bulletin)
    	
    	get_categorys
    	get_tags
    end
  end

  # POST /news_bulletins
  # POST /news_bulletins.xml
  def create
	
	if params[:news_bulletin_link]
  
		@news_bulletin_link = NewsBulletinLink.new(params[:news_bulletin_link])

		respond_to do |format|
		  if @news_bulletin_link.save
			format.js { render 'create_news_bulletin_link' }
		  end
		end
	
	elsif params[:news_bulletin_file]
  
		@news_bulletin_file = NewsBulletinFile.new(params[:news_bulletin_file])

		respond_to do |format|
		  if @news_bulletin_file.save
			format.js { render 'create_news_bulletin_file' }
		  end
		end
	
	else  
  
		@news_bulletin = NewsBulletin.new(params[:news_bulletin])
		
		@news_bulletin.create_user_id = current_user.id
		@news_bulletin.update_user_id = current_user.id

		respond_to do |format|
		  if @news_bulletin.save
			# format.html { redirect_to(panel_news_back_end_news_bulletin_url(@news_bulletin), :notice => t('news.create_news_bulletin_success')) }
			format.html { redirect_to(panel_news_back_end_news_bulletins_url, :notice => t('news.create_news_bulletin_success')) }
			format.xml  { render :xml => @news_bulletin, :status => :created, :location => @news_bulletin }
			format.js
		  else
			format.html { render :action => "new" }
			format.xml  { render :xml => @news_bulletin.errors, :status => :unprocessable_entity }
		  end
		end
		
	end
	
  end

  def link_quick_add
	# debugger
    
    @news_bulletin_link = NewsBulletinLink.new
	@link_url = panel_news_back_end_news_bulletins_path
	
	@news_bulletin_link.news_bulletin_id = params[:news_bulletin_id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def link_quick_edit
	# debugger
    @news_bulletin_link = NewsBulletinLink.find(params[:news_bulletin_id])
	
	@link_url = panel_news_back_end_news_bulletin_path(@news_bulletin_link)
	
    # @news_bulletin = NewsBulletin.find(params[:news_bulletin_id])
	
	# @link_url = panel_news_back_end_news_bulletin_path(@news_bulletin)
	
    respond_to do |format|
      format.js
    end
	
  end

  def file_quick_add
    # debugger
    
    @news_bulletin_file = NewsBulletinFile.new
    @file_url = panel_news_back_end_news_bulletins_path
	
    @news_bulletin_file.news_bulletin_id = params[:news_bulletin_id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def file_quick_edit
    # debugger
    @news_bulletin_file = NewsBulletinFile.find(params[:news_bulletin_id])
	
    @file_url = panel_news_back_end_news_bulletin_path(@news_bulletin_file)
	
    respond_to do |format|
      format.js
    end
  end

  # PUT /news_bulletins/1
  # PUT /news_bulletins/1.xml
  def update
	
  	if params[:news_bulletin_link]
  	
  		@news_bulletin_link = NewsBulletinLink.find(params[:id])
  		
  		@link_url = panel_news_back_end_news_bulletin_path(@news_bulletin_link)

  		respond_to do |format|
  		  if @news_bulletin_link.update_attributes(params[:news_bulletin_link])
  			# format.html { redirect_to(panel_news_back_end_news_bulletins_url) }
  			format.js { render 'update_news_bulletin_link' }
  		  end
  		end
  	
  	elsif params[:news_bulletin_file]
  	
  		@news_bulletin_file = NewsBulletinFile.find(params[:id])
  		
  		@file_url = panel_news_back_end_news_bulletin_path(@news_bulletin_file)

  		respond_to do |format|
  		  if @news_bulletin_file.update_attributes(params[:news_bulletin_file])
  			# format.html { redirect_to(panel_news_back_end_news_bulletins_url) }
  			format.js { render 'update_news_bulletin_file' }
  		  end
  		end
  	
  	else
    
  		@news_bulletin = NewsBulletin.find(params[:id])
  		
  		@news_bulletin.update_user_id = current_user.id
  		
  		# @news_bulletin.image.clear if params[:news_bulletin][:image_del] == '1'
  		# if params[:news_bulletin][:image_del] == '1' 
  			# @news_bulletin.remove_image!
  			# @news_bulletin.image_del = nil
  			# params[:news_bulletin][:image_del] = nil
  		# end

  		respond_to do |format|
  		  if @news_bulletin.update_attributes(params[:news_bulletin])
  			# format.html { redirect_to(panel_news_back_end_news_bulletin_url(@news_bulletin), :notice => t('news_bulletin.update_news_bulletin_success')) }
  			format.html { redirect_to(panel_news_back_end_news_bulletins_url, :notice => t('news_bulletin.update_news_bulletin_success')) }
  			format.js  { render 'toggle_enable' }
  			format.xml  { head :ok }
  		  else
          get_tags
          get_categorys
  			format.html { render :action => "edit" }
  			format.xml  { render :xml => @news_bulletin.errors, :status => :unprocessable_entity }
  		  end
  		end
		
    end
	
  end

  # DELETE /news_bulletins/1
  # DELETE /news_bulletins/1.xml
  def destroy
    @news_bulletin = NewsBulletin.find(params[:id])
    # @news_bulletin.news_bulletin_files.destroy
    @news_bulletin.destroy

    respond_to do |format|
      format.html { redirect_to(panel_news_back_end_news_bulletins_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  # def top_edit
	
	# NewsBulletin.where(id: params[:id]).update_all( is_top: true )
    # respond_to do |format|
      # format.html { redirect_to(panel_news_back_end_news_bulletins_url) }
      # format.xml  { head :ok }
    # end
	
  # end
  

  def load_quick_edit
    @news_bulletin = NewsBulletin.find(params[:id])
    @type = params[:type]
    @news_bulletin_categories = NewsBulletinCategory.all
    get_tags
  end

  def delete
    if params[:to_delete]
      news_bulletins = NewsBulletin.any_in(:_id => params[:to_delete]).delete_all
    end
    redirect_to panel_news_back_end_news_bulletins_url(:filter => params[:filter], :direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end

  
  protected
  
  def get_categorys(id = nil)
    @news_bulletin_categorys = []
    if(is_manager? || is_admin?)
      @news_bulletin_categorys = (id ? NewsBulletinCategory.find(id).to_a : NewsBulletinCategory.excludes('disabled' => true))
    elsif is_sub_manager?
      @news_bulletin_categorys = NewsBulletinCategory.authed_for_user(current_user,'submit_new')
    end
  end
  
  def get_tags
  	module_app = ModuleApp.first(:conditions => {:key => 'news'})
  	@tags = Tag.all(:conditions => {:module_app_id => module_app.id}).order_by(I18n.locale, :asc)
  end

  def get_sorted_and_filtered_news_bulletins
    news_bulletins = NewsBulletin.all
    case params[:sort]
      when 'postdate', 'deadline'
        news_bulletins = news_bulletins.order_by([params[:sort], params[:direction]])
      when 'category'
        category_ids = news_bulletins.distinct(:news_bulletin_category_id)
        categories = NewsBulletinCategory.find(category_ids) rescue nil
        if categories
          h = Hash.new 
          categories.each { |category| h[category.i18n_variable[I18n.locale]] = category.id }
          sorted = params[:direction].eql?('asc') ? h.sort : h.sort.reverse!
          sorted_categorys = sorted.collect {|a| news_bulletins.where(:news_bulletin_category_id => a[1]).entries }
          news_bulletins = sorted_categorys.flatten!
        end
      when 'title'
        h = Array.new 
        news_bulletins.each { |news_bulletin| h << [news_bulletin.title[I18n.locale].downcase, news_bulletin] }
        sorted = params[:direction].eql?('asc') ? h.sort : h.sort.reverse!
        news_bulletins = sorted.collect {|a| a[1] }
      when 'status'
        news_bulletins = news_bulletins.order_by(:is_top, params[:direction]).order_by(:is_hot, params[:direction]).order_by(:is_hidden, params[:direction]).order_by(:is_pending, params[:direction]).order_by(:is_checked, params[:direction]).order_by(:is_rejected, params[:direction])
      when 'update_user_id'
        user_ids = news_bulletins.distinct(:update_user_id)
        users = User.find(user_ids) rescue nil
        if users
          h = Array.new 
          users.each { |user| h << [user.name, user.id] }
          sorted = params[:direction].eql?('asc') ? h.sort : h.sort.reverse!
          sorted_users = sorted.collect {|a| news_bulletins.where(:update_user_id => a[1]).entries }
          news_bulletins = sorted_users.flatten
        end
      when 'tags'
        a = Array.new
        NewsTag.all.order_by(I18n.locale, params[:direction]).each { |tag| a << tag.news_bulletins }
        a.flatten!
        a.uniq!
        tmp = Array.new 
        news_bulletins.where(:tag_ids => []).each { |news_bulletin| tmp << [news_bulletin.title[I18n.locale].downcase, news_bulletin] }
        sorted = params[:direction].eql?('asc') ? tmp.sort : tmp.sort.reverse!
        sorted_titles = sorted.collect {|a| a[1] }
        a = params[:direction].eql?('asc') ? (sorted_titles + a) : (a + sorted_titles)
        news_bulletins = a.flatten
    end
    if @filter
      @filter.each do |key, value|
        case key
          when 'status'
            a = Array.new
            news_bulletins.each do |news_bulletin|
              value.each do |v|
                case v
                  when 'pending'
                    a << news_bulletin if news_bulletin.is_checked.nil?
                  when 'rejected'
                    a << news_bulletin if news_bulletin.is_checked.eql?(false)
                  else
                    a << news_bulletin if news_bulletin[v]
                end
              end
            end
            news_bulletins = a.uniq
          when 'categories'
            a = Array.new
            news_bulletins.each do |news_bulletin|
              a << news_bulletin if value.include?(news_bulletin.news_bulletin_category.id.to_s)
            end
            news_bulletins = a.uniq
          when 'tags'
            a = Array.new
            news_bulletins.each do |news_bulletin|
              news_bulletin.tags.each do |tag|
                a << news_bulletin if value.include?(tag.id.to_s)
              end
            end
            news_bulletins = a.uniq
        end if value.size > 0
      end
    end
    Kaminari.paginate_array(news_bulletins).page(params[:page]).per(10)
  end
  
end
